;##################################################
;##                                              ##
;##        [ Asm7x.List ][ ISortS1.inc ]         ##
;##                                              ##
;##             -= Insertion Sort =-             ##
;##         (for single element arrays)          ##
;##                                              ##
;##             ஢ ⠢             ##
;##    ( ᨢ  묨 ⠬)    ##
;##                                              ##
;##           [ v1.00 :: 11.11.2017 ]            ##
;##              MASM/TASM (16 bit)              ##
;##                                              ##
;##     (c) 2017 by Jin X (jin.x@sources.ru)     ##
;##             http://xk7.ru/p/a/i              ##
;##                                              ##
;##################################################

IFDEF		??Version	; TASM
  LOCALS
ENDIF

ISortS1_ver	=	100h			;    (word: 訩  - 楫 , 訩 - ஡)

; !!!   㫥 ᯮ  ࠢ 祭  ஢   ( 襣  襬)
; !!!     ࠢ  ஢   室  ᮮ⢥騥 樨, 祭   ᨬ ***

;-----------------------------------------------------------------------------------------------------------------------

;-- InsSort:  ᨢ  ------------------------------------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
;  ᨢ ᮤঠ  1 祭 ⨯ WORD,  ஬ ந室 ࠢ  ஢
; 楤  ॣ AX, BX, SI, DI, ࠭ CX, DX, BP  ᥣ ॣ
InsSort		PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		shl	cx,1
		add	cx,dx			; CX =  ᫥ 

		;  楤 ஢ ⠢
		; DX =  ࢮ , CX =  ᫥ , CX > DX
		mov	di,dx			; J (DI) := L -  ࢮ 
	@@next:					;; for J (DI) := L+1 (CX) to R (DX) do
		add	di,2			; J++ (DI) -  ᫥饣 ஢塞  ( ᭮ 横)
		mov	bx,[di]			;; T (BX) := [J]
		mov	si,di			; I+1 (SI) := DI -  , ᫥饣  ࠢ ( ७ 横)
	@@loop:					;; repeat
		mov	ax,[si-2]
		cmp	ax,bx			;; if [I] > T then
		jle	@@break			; 룠, ᫨ [I] <= T {*** ஢  ⠭: jle -  ࠢ, jbe - ;  뢠: jge - , jae - }

		mov	[si],ax			;;  [I+1] := [I] else Break

		sub	si,2			;; Dec(I)
		cmp	si,dx
		jnbe	@@loop			;; until I < L (I+1 <= L)
	@@break:
		mov	[si],bx			;; [I+1] := T

		cmp	di,cx
		jnae	@@next			; ᫥騩  ᨢ ;; end for
	@@exit:	ret
InsSort		ENDP
